# coding: utf-8

"""
    Event Ingestion API

    Event Ingestion API client for DataKitchen’s DataOps Observability  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@datakitchen.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MessageLogEventApiSchema(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'server_key': 'str',
        'dataset_name': 'str',
        'server_name': 'str',
        'message': 'str',
        'external_url': 'str',
        'metadata': 'object',
        'run_key': 'str',
        'stream_name': 'str',
        'task_key': 'str',
        'pipeline_name': 'str',
        'log_level': 'str',
        'run_name': 'str',
        'event_timestamp': 'datetime',
        'dataset_key': 'str',
        'task_name': 'str',
        'pipeline_key': 'str',
        'stream_key': 'str'
    }

    attribute_map = {
        'server_key': 'server_key',
        'dataset_name': 'dataset_name',
        'server_name': 'server_name',
        'message': 'message',
        'external_url': 'external_url',
        'metadata': 'metadata',
        'run_key': 'run_key',
        'stream_name': 'stream_name',
        'task_key': 'task_key',
        'pipeline_name': 'pipeline_name',
        'log_level': 'log_level',
        'run_name': 'run_name',
        'event_timestamp': 'event_timestamp',
        'dataset_key': 'dataset_key',
        'task_name': 'task_name',
        'pipeline_key': 'pipeline_key',
        'stream_key': 'stream_key'
    }

    def __init__(self, server_key=None, dataset_name=None, server_name=None, message=None, external_url=None, metadata=None, run_key=None, stream_name=None, task_key=None, pipeline_name=None, log_level=None, run_name=None, event_timestamp=None, dataset_key=None, task_name=None, pipeline_key=None, stream_key=None):  # noqa: E501
        """MessageLogEventApiSchema - a model defined in Swagger"""  # noqa: E501
        self._server_key = None
        self._dataset_name = None
        self._server_name = None
        self._message = None
        self._external_url = None
        self._metadata = None
        self._run_key = None
        self._stream_name = None
        self._task_key = None
        self._pipeline_name = None
        self._log_level = None
        self._run_name = None
        self._event_timestamp = None
        self._dataset_key = None
        self._task_name = None
        self._pipeline_key = None
        self._stream_key = None
        self.discriminator = None
        if server_key is not None:
            self.server_key = server_key
        if dataset_name is not None:
            self.dataset_name = dataset_name
        if server_name is not None:
            self.server_name = server_name
        self.message = message
        if external_url is not None:
            self.external_url = external_url
        if metadata is not None:
            self.metadata = metadata
        if run_key is not None:
            self.run_key = run_key
        if stream_name is not None:
            self.stream_name = stream_name
        if task_key is not None:
            self.task_key = task_key
        if pipeline_name is not None:
            self.pipeline_name = pipeline_name
        self.log_level = log_level
        if run_name is not None:
            self.run_name = run_name
        if event_timestamp is not None:
            self.event_timestamp = event_timestamp
        if dataset_key is not None:
            self.dataset_key = dataset_key
        if task_name is not None:
            self.task_name = task_name
        if pipeline_key is not None:
            self.pipeline_key = pipeline_key
        if stream_key is not None:
            self.stream_key = stream_key

    @property
    def server_key(self):
        """Gets the server_key of this MessageLogEventApiSchema.  # noqa: E501

        The key identifier of the target server component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :return: The server_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._server_key

    @server_key.setter
    def server_key(self, server_key):
        """Sets the server_key of this MessageLogEventApiSchema.

        The key identifier of the target server component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :param server_key: The server_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._server_key = server_key

    @property
    def dataset_name(self):
        """Gets the dataset_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Human readable display name for the dataset component.  # noqa: E501

        :return: The dataset_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._dataset_name

    @dataset_name.setter
    def dataset_name(self, dataset_name):
        """Sets the dataset_name of this MessageLogEventApiSchema.

        Optional. Human readable display name for the dataset component.  # noqa: E501

        :param dataset_name: The dataset_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._dataset_name = dataset_name

    @property
    def server_name(self):
        """Gets the server_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Human readable display name for the server.  # noqa: E501

        :return: The server_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._server_name

    @server_name.setter
    def server_name(self, server_name):
        """Sets the server_name of this MessageLogEventApiSchema.

        Optional. Human readable display name for the server.  # noqa: E501

        :param server_name: The server_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._server_name = server_name

    @property
    def message(self):
        """Gets the message of this MessageLogEventApiSchema.  # noqa: E501

        Required. The body of the message to log.  # noqa: E501

        :return: The message of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this MessageLogEventApiSchema.

        Required. The body of the message to log.  # noqa: E501

        :param message: The message of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    @property
    def external_url(self):
        """Gets the external_url of this MessageLogEventApiSchema.  # noqa: E501

        A link to source information.  # noqa: E501

        :return: The external_url of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._external_url

    @external_url.setter
    def external_url(self, external_url):
        """Sets the external_url of this MessageLogEventApiSchema.

        A link to source information.  # noqa: E501

        :param external_url: The external_url of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._external_url = external_url

    @property
    def metadata(self):
        """Gets the metadata of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Additional key-value information for the event. Provided by the user as needed.  # noqa: E501

        :return: The metadata of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this MessageLogEventApiSchema.

        Optional. Additional key-value information for the event. Provided by the user as needed.  # noqa: E501

        :param metadata: The metadata of this MessageLogEventApiSchema.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def run_key(self):
        """Gets the run_key of this MessageLogEventApiSchema.  # noqa: E501

        The identifier of the target run for the event action. This key is created and managed by the user. Required if the target component is a batch-pipeline.   # noqa: E501

        :return: The run_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._run_key

    @run_key.setter
    def run_key(self, run_key):
        """Sets the run_key of this MessageLogEventApiSchema.

        The identifier of the target run for the event action. This key is created and managed by the user. Required if the target component is a batch-pipeline.   # noqa: E501

        :param run_key: The run_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._run_key = run_key

    @property
    def stream_name(self):
        """Gets the stream_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Human readable display name for the streaming-pipeline.  # noqa: E501

        :return: The stream_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._stream_name

    @stream_name.setter
    def stream_name(self, stream_name):
        """Sets the stream_name of this MessageLogEventApiSchema.

        Optional. Human readable display name for the streaming-pipeline.  # noqa: E501

        :param stream_name: The stream_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._stream_name = stream_name

    @property
    def task_key(self):
        """Gets the task_key of this MessageLogEventApiSchema.  # noqa: E501

        Optional. The identifier for a run task. When no task_key is included, the event applies to the run specified by the run_key.  # noqa: E501

        :return: The task_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._task_key

    @task_key.setter
    def task_key(self, task_key):
        """Sets the task_key of this MessageLogEventApiSchema.

        Optional. The identifier for a run task. When no task_key is included, the event applies to the run specified by the run_key.  # noqa: E501

        :param task_key: The task_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._task_key = task_key

    @property
    def pipeline_name(self):
        """Gets the pipeline_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Human readable display name for the batch-pipeline component.  # noqa: E501

        :return: The pipeline_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_name

    @pipeline_name.setter
    def pipeline_name(self, pipeline_name):
        """Sets the pipeline_name of this MessageLogEventApiSchema.

        Optional. Human readable display name for the batch-pipeline component.  # noqa: E501

        :param pipeline_name: The pipeline_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._pipeline_name = pipeline_name

    @property
    def log_level(self):
        """Gets the log_level of this MessageLogEventApiSchema.  # noqa: E501

        Required. The severity level of the message.  # noqa: E501

        :return: The log_level of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._log_level

    @log_level.setter
    def log_level(self, log_level):
        """Sets the log_level of this MessageLogEventApiSchema.

        Required. The severity level of the message.  # noqa: E501

        :param log_level: The log_level of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """
        if log_level is None:
            raise ValueError("Invalid value for `log_level`, must not be `None`")  # noqa: E501
        allowed_values = ["ERROR", "WARNING", "INFO"]  # noqa: E501
        if log_level not in allowed_values:
            raise ValueError(
                "Invalid value for `log_level` ({0}), must be one of {1}"  # noqa: E501
                .format(log_level, allowed_values)
            )

        self._log_level = log_level

    @property
    def run_name(self):
        """Gets the run_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. Human readable display name for the run.  # noqa: E501

        :return: The run_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._run_name

    @run_name.setter
    def run_name(self, run_name):
        """Sets the run_name of this MessageLogEventApiSchema.

        Optional. Human readable display name for the run.  # noqa: E501

        :param run_name: The run_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._run_name = run_name

    @property
    def event_timestamp(self):
        """Gets the event_timestamp of this MessageLogEventApiSchema.  # noqa: E501

        Optional. An ISO8601 timestamp that describes when the event occurred. If no timezone is specified, UTC is assumed. If unset, the Event Ingestion API applies its current time as the value.  # noqa: E501

        :return: The event_timestamp of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: datetime
        """
        return self._event_timestamp

    @event_timestamp.setter
    def event_timestamp(self, event_timestamp):
        """Sets the event_timestamp of this MessageLogEventApiSchema.

        Optional. An ISO8601 timestamp that describes when the event occurred. If no timezone is specified, UTC is assumed. If unset, the Event Ingestion API applies its current time as the value.  # noqa: E501

        :param event_timestamp: The event_timestamp of this MessageLogEventApiSchema.  # noqa: E501
        :type: datetime
        """

        self._event_timestamp = event_timestamp

    @property
    def dataset_key(self):
        """Gets the dataset_key of this MessageLogEventApiSchema.  # noqa: E501

        The key identifier of the target dataset component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :return: The dataset_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._dataset_key

    @dataset_key.setter
    def dataset_key(self, dataset_key):
        """Sets the dataset_key of this MessageLogEventApiSchema.

        The key identifier of the target dataset component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :param dataset_key: The dataset_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._dataset_key = dataset_key

    @property
    def task_name(self):
        """Gets the task_name of this MessageLogEventApiSchema.  # noqa: E501

        Optional. A human-readable display name for the task.  # noqa: E501

        :return: The task_name of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._task_name

    @task_name.setter
    def task_name(self, task_name):
        """Sets the task_name of this MessageLogEventApiSchema.

        Optional. A human-readable display name for the task.  # noqa: E501

        :param task_name: The task_name of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._task_name = task_name

    @property
    def pipeline_key(self):
        """Gets the pipeline_key of this MessageLogEventApiSchema.  # noqa: E501

        The key identifier of the target batch-pipeline component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :return: The pipeline_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_key

    @pipeline_key.setter
    def pipeline_key(self, pipeline_key):
        """Sets the pipeline_key of this MessageLogEventApiSchema.

        The key identifier of the target batch-pipeline component for the event action. Only one component key can be provided at a time.  # noqa: E501

        :param pipeline_key: The pipeline_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._pipeline_key = pipeline_key

    @property
    def stream_key(self):
        """Gets the stream_key of this MessageLogEventApiSchema.  # noqa: E501

        The key identifier of the target streaming-pipeline for the event action. Only one component key can be provided at a time.  # noqa: E501

        :return: The stream_key of this MessageLogEventApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._stream_key

    @stream_key.setter
    def stream_key(self, stream_key):
        """Sets the stream_key of this MessageLogEventApiSchema.

        The key identifier of the target streaming-pipeline for the event action. Only one component key can be provided at a time.  # noqa: E501

        :param stream_key: The stream_key of this MessageLogEventApiSchema.  # noqa: E501
        :type: str
        """

        self._stream_key = stream_key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MessageLogEventApiSchema, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MessageLogEventApiSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
